/* Problem URL: https://codeforces.com/problemset/problem/2029/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m;
    cin >> n >> m;

    vvi graph(n);
    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    V<bool> vis(n);
    V<bool> frame(n);
    vi cur(n);

    set<pair<int, int>> rem;
    vvi loops;
    int end = -1;

    function<bool(int, int)> dfs = [&](int i, int p) {
        vis[i] = true;
        frame[i] = true;

        for (int &k = cur[i]; k < graph[i].size(); k++) {
            int j = graph[i][k];
            
            if (j == p) {
                continue;
            }

            if (rem.count({i, j})) {
                continue;
            }

            if (frame[j]) {
                end = j;
                loops.emplace_back();
                loops.back().push_back(i);
                frame[i] = false;
                vis[i] = false;
                rem.emplace(i, j);
                rem.emplace(j, i);
                return true;
            }

            if (vis[j]) {
                continue;
            }
            
            if (dfs(j, i)) {
                loops.back().push_back(i);
                rem.emplace(i, j);
                rem.emplace(j, i);
                if (end != i) {
                    frame[i] = false;
                    vis[i] = false;
                    return true;
                }
            }
        }

        frame[i] = false;
        return false;
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }
        dfs(i, i);
    }

    int c = 0;

    V<tuple<int, int, int>> ans;
    repv(j, loops) {
        nrep(i, 2, j.size()) {
            ans.emplace_back(j[0] + 1, j[i - 1] + 1, j[i] + 1);
        }
    }

    auto printans = [&]() {
        cout << ans.size() << '\n';
        for (auto [i, j, k] : ans) {
            cout << i << ' ' << j << ' ' << k << '\n';
        }
    };

    vvi act(n);
    rep(i, n) {
        repv(j, graph[i]) {
            if (rem.count({i, j})) {
                continue;
            }
            act[i].push_back(j);
            c++;
        }
    }

    if (c == 0) {
        printans();
        return;
    }

    fill(all(vis), false);
    vi g(n);
    int gg = 0;
    set<int> ev;

    function<void(int)> func = [&](int i) {
        vis[i] = true;
        g[i] = gg;

        repv(j, act[i]) {
            if (vis[j]) {
                continue;
            }

            func(j);
        }
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }
        func(i);
        gg++;
    }

    int a1 = -1;
    int a2 = -1;
    rep(i, n) {
        if (act[i].size() > 0) {
            a1 = i;
            a2 = act[i][0];
            ev.insert(g[i]);
            break;
        }
    }

    rep(i, n) {
        if (!ev.count(g[i])) {
            ans.emplace_back(a1 + 1, a2 + 1, i + 1);
            ev.insert(g[i]);
            a1 = i;
        }
    }

    printans();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
